function Get-AppList
{
  begin
  {
    $config = "$PSScriptRoot\AppRemove.xml"
    if (Test-Path -Path $config)
    {

      Write-Host "Lese Konfiguration von $config ein"
      $list = Get-Content $config
    }
    else
    {
      Write-Verbose "Erstelle Liste..."
      $list = @()
      if ($script:Offline)
      {
        Get-AppxProvisionedPackage -Path $script:OfflinePath | % { $list += $_.DisplayName }
      }
      else
      {
        Get-AppxProvisionedPackage -Online | % { $list += $_.DisplayName }
      }

      $config = "$PSScriptRoot\AppRemove.xml"
      $list | Set-Content $config
      Write-Host "Die Liste wurde erstellt $logDir\AppRemove.xml"
    }

    Write-Information "Zu entfernende Apps wurden ermittelt: $list.Count"

    }

  process
  {
    $list
  }
  }


  ####

  function Remove-App
{
  [CmdletBinding()]
  param (
        [parameter(Mandatory=$true,ValueFromPipeline=$true)]
        [string] $appName
  )

  begin
  {
    # Determine offline or online
    if ($script:Offline)
    {
      $script:Provisioned = Get-AppxProvisionedPackage -Path $script:OfflinePath
    }
    else
    {
      $script:Provisioned = Get-AppxProvisionedPackage -Online
      $script:AppxPackages = Get-AppxPackage
    }
  }

  process
  {
    $app = $_

    Write-Information "Entferne bereitgestellte Pakete package $_"
    $current = $script:Provisioned | ? { $_.DisplayName -eq $app }
    if ($current)
    {
      if ($script:Offline)
      {
        $a = Remove-AppxProvisionedPackage -Path $script:OfflinePath -PackageName $current.PackageName
      }
      else
      {
        $a = Remove-AppxProvisionedPackage -Online -PackageName $current.PackageName
      }
    }
    else
    {
      Write-Warning "Kann bereitgestellte Pakete nicht finden  $_"
    }

    if (-not $script:Offline)
    {
      Write-Information "Entferne bereitgestelltes Paket $_"
      $current = $script:AppxPackages | ? {$_.Name -eq $app }
      if ($current)
      {
        $current | Remove-AppxPackage
      }
      else
      {
        Write-Warning "Unable to find installed app $_"
      }
    }

  }
}
  Get-AppList | Remove-App